//
//  ZhangFanCustomAlertView.m
//  TankuangView
//
//  Created by 高备资产 on 16/4/14.
//  Copyright © 2016年 高备资产. All rights reserved.
//

#import "ZhangFanCustomAlertView.h"
#import "ZhangFanCustomLineView.h"

#define Bound_Width  [[UIScreen mainScreen] bounds].size.width
#define Bound_Height [[UIScreen mainScreen] bounds].size.height
#define Window_      [[UIApplication sharedApplication].delegate window]

@interface ZhangFanCustomAlertView()
@property (weak, nonatomic) IBOutlet UILabel *title;
@property (weak, nonatomic) IBOutlet UIButton *btn1;
@property (weak, nonatomic) IBOutlet UIButton *btn2;
@property (weak, nonatomic) IBOutlet ZhangFanCustomLineView *topLine;
@property (weak, nonatomic) IBOutlet ZhangFanCustomLineView *cancelBtn;
@property (nonatomic, strong) UIView *backView;
@end

@implementation ZhangFanCustomAlertView

+ (ZhangFanCustomAlertView *)sharedCustomAlertView{
    static ZhangFanCustomAlertView *customAlertView = nil;
    static dispatch_once_t alertView;
    dispatch_once(&alertView, ^{
        customAlertView = [[[NSBundle mainBundle] loadNibNamed:@"ZhangFanCustomAlertView" owner:self options:nil] lastObject];
    });
    return customAlertView;
}
+ (void)showTitle:(NSString *)title bt1Title
                 :(NSString *)bt1Title bt2Title
                 :(NSString *)bt2Title CancelButtonTitle
                 :(NSString *)cancelTitle btn1Block
                 :(btn1Block)btn1Block btn2Block
                 :(btn2Block)btn2Block CancelBlock
                 :(CancelBlock)cancel{
    [[ZhangFanCustomAlertView sharedCustomAlertView]showTitle:title bt1Title:bt1Title bt2Title:bt2Title CancelButtonTitle:cancelTitle btn1Block:btn1Block btn2Block:btn2Block CancelBlock:cancel];
}
- (void)showTitle:(NSString *)title bt1Title
                 :(NSString *)bt1Title bt2Title
                 :(NSString *)bt2Title CancelButtonTitle
                 :(NSString *)cancelTitle btn1Block
                 :(btn1Block)btn1Block btn2Block
                 :(btn2Block)btn2Block CancelBlock
                 :(CancelBlock)cancel{
    self.btn1Block = btn1Block;
    self.btn2Block = btn2Block;
    self.cancelBlock = cancel;
    [self loadUI];
    [self showView];
    
}
- (void)loadUI{
    [self.backView removeFromSuperview];
    [self removeFromSuperview];
    self.backView         = [[UIView alloc]initWithFrame:CGRectMake(0, 0, Bound_Width, Bound_Height)];
    self.backView.backgroundColor = [UIColor colorWithRed:0 green:0 blue:0 alpha:0.2];
    [Window_ addSubview:self.backView];

    self.frame               = CGRectMake(Bound_Width/2-250/2, -150, 250, 150);
    self.backgroundColor     = [UIColor colorWithRed:0.976f green:0.976f blue:0.976f alpha:0.95f];
    self.layer.cornerRadius  = 10.0;
    self.layer.borderWidth   = 0.6;
    self.layer.borderColor   = [UIColor colorWithRed:0.698f green:0.698f blue:0.698f alpha:1.00f].CGColor;
    [Window_ addSubview:self];
    
    //移动手势
    UIPanGestureRecognizer *panGestureRecognizer = [[UIPanGestureRecognizer alloc]
                                                    initWithTarget:self
                                                    action:@selector(handlePan:)];
    [self addGestureRecognizer:panGestureRecognizer];
}

- (void)showView{
    [UIView animateWithDuration:1.5 delay:0 usingSpringWithDamping:0.3 initialSpringVelocity:0 options:UIViewAnimationOptionCurveEaseInOut animations:^{
        self.center = Window_.center;
    } completion:^(BOOL finished) {
    }];
}
- (void)handlePan:(UIPanGestureRecognizer *)pan{
    
    CGPoint translation = [pan translationInView:Window_];
    pan.view.center = CGPointMake(pan.view.center.x + translation.x,
                                  pan.view.center.y + translation.y);
    [pan setTranslation:CGPointZero inView:Window_];
    
    CGRect frame = pan.view.frame;
    if (pan.view.frame.origin.x < 0) {
        frame.origin.x = 0;
    }
    if (pan.view.frame.origin.x > Bound_Width - pan.view.frame.size.width) {
        frame.origin.x = Bound_Width - pan.view.frame.size.width;
    }
    if (pan.view.frame.origin.y < 20) {
        frame.origin.y = 20;
    }
    if (pan.view.frame.origin.y > Bound_Height - pan.view.frame.size.height) {
        frame.origin.y = Bound_Height - pan.view.frame.size.height;
    }
    pan.view.frame = frame;
    
    if (pan.state == UIGestureRecognizerStateEnded) {
        [self showView];
    }
}

- (IBAction)clickBtn1:(id)sender {
    [self dismiss];
    if (self.btn1Block != nil) {
        self.btn1Block();
    }
}

- (IBAction)clickBtn2:(id)sender {
    [self dismiss];
    if (self.btn2Block != nil) {
        self.btn2Block();
    }
}

- (IBAction)clickCancle:(id)sender {
    [self dismiss];

    if (self.cancelBlock != nil) {
        self.cancelBlock();
    }
}

- (void)dismiss{
    [UIView animateWithDuration:0.3 animations:^{
        CGRect frame = self.frame;
        frame.origin.y = Bound_Height;
        self.frame = frame;
    } completion:^(BOOL finished) {
        [self.backView removeFromSuperview];
        [self removeFromSuperview];
    }];
}

@end
